#include <pic.h>
// 1, 8MHz, HMC5883  c    
__CONFIG(0x03F72);


unsigned char mas8[10] = {
    0b00110000,
    0b00110001,
    0b00110010,
    0b00110011,
    0b00110100,
    0b00110101,
    0b00110110,
    0b00110111,
    0b00111000,
    0b00111001 };			//  WH0802


unsigned char KS;	        		// 	 
unsigned char time;	            	//   
unsigned char prevstat;
unsigned char currstat;
unsigned int i;
unsigned int j;
unsigned char LOOP;
unsigned char k;
unsigned char AcpValues;   //    AN0
unsigned int DATA;      //.   
signed long int DATA_X;     //    
signed long int DATA_Y;     //    Y
signed long int DATA_Z;     //    Z
signed int bank1 DATA_XM[8];     //    
signed int bank1 DATA_YM[8];     //    Y
signed int bank1 DATA_ZM[8];     //    Z
unsigned char DO=6;       //    0...6 (0,75...75)  //3  //6
unsigned char MA=0;       //  0...3 (1...8)  //3  //0
unsigned char GN=7;         //  0...7  (0,88...8,1)
unsigned char znak;       //  +/-
int DATA_H;
unsigned char START; // 5-5 10-10
unsigned char l;
unsigned char m;
unsigned int tms=560;

//////////////////////    I2C  //////////////////////////////////
void I2C_start (void)
{
BCLIF=0;
SSPIF = 0; //  
SEN = 1; //   
while(!SSPIF); //   
SSPIF = 0; //  
}

void I2C_restart (void)
{
BCLIF=0;
SSPIF = 0; //  
RSEN = 1; //   
while(!SSPIF); //   
SSPIF = 0; //  
}

void I2C_stop (void)
{
BCLIF=0;
SSPIF = 0; //  
PEN = 1; //   
while(!SSPIF); //   
SSPIF = 0; //  
}

void I2C_ack (void)
{
BCLIF=0;
SSPIF = 0; //  
ACKEN = 1; //   
while(!SSPIF); //   
SSPIF = 0; //  
}

void I2C_nak(void)
{
while (!SSPIF && !BCLIF);
ACKDT = 1; 
ACKEN = 1; //   
while(!SSPIF); //   
}

void send_byte(unsigned char word)
{
SSPIF = 0; //  
SSPBUF = word;  //  /                            
while(!SSPIF); //   
SSPIF = 0; //  
}

void I2C_send(unsigned char word)
{
	BCLIF=0;
	SSPIF=0;
	SSPBUF=word;
	while (!SSPIF && !BCLIF);
	BCLIF=0;
	SSPIF=0;
//	if (BCLIF) i2c_error=1;
//	if (ACKSTAT) return 1;
//	return 0;
}

void read_byte(void)
{
	BCLIF=0;
	SSPIF=0;
	RCEN=1; 
	while (!SSPIF && !BCLIF);
//	if (BCLIF) i2c_error=1;
//	N = SSPBUF;
	ACKDT=1;
	BCLIF=0;
	SSPIF=0;
	ACKEN=1;
    RCEN = 0;
	while (!SSPIF && !BCLIF);
	
}

//////////////////////////////////////////////////////////////////////





void Delay(int count)
{
	for(j = 0; j < count; j++)
	{
		j++;
		j--;
		j++;
		j--;
		j++;
		j--;
		j++;
		j--;
    }
}



void WriteCom(unsigned char value)
{
	while(TXIF == 0)
		;
	TXREG = value;
}


//   -        
void interrupt IntFun(void)
{ 
   	if(T0IF)
   	{
		T0IF=0;
	//	ADGO=1;//  

		//while(ADGO==1)
	//	{
		//}

		AcpValues = ((ADRESH << 8) | ADRESL); //  10	
    
	 //   ADCON0 = 0b10000001;
	    
   	}
}



void LOAD_QMC5883(void)
{

I2C_start();  //2  
I2C_send (0x1A);    //write to qMC
I2C_send (0x0A);    //conf reg 
I2C_send (0x80);    //soft reset
I2C_stop();
Delay(10000);

I2C_start();  //2  
I2C_send (0x1A);    //write to qMC
I2C_send (0x0B);    //conf reg 
I2C_send (0x01);    //value for confA ()
I2C_stop();
Delay(50);

I2C_start();  //2  
I2C_send (0x1A);    //write to qMC
I2C_send (0x09);    //conf reg 
I2C_send (0x1D);    //value for confA (   /  8Gauss /100/  )
I2C_stop();
Delay(50);


}





void LOAD_HMC5883(void)
{
I2C_start();  //2  
I2C_send (0x3C);    //write to HMC
I2C_send (0x00);    //confA reg 
//I2C_send (0x70);    //value for confA 
I2C_send (((DO<<2)|(MA<<5))&0b01111100);    //value for confA (  )
I2C_stop();
Delay(10);

I2C_start();  //2  
I2C_send (0x3C);    //write to HMC
I2C_send (0x01);    //confB reg 
//I2C_send (0xA0);    //value for confB 
I2C_send ((GN<<5)&0b11100000);    //value for confB ( )
I2C_stop();
Delay(10);

I2C_start();  //2  
I2C_send (0x3C);    //write to HMC
I2C_send (0x02);    //conf mode register 
I2C_send (0x00);    //value for conf mode (  )
I2C_stop();
Delay(10);
}

void READ_HMC5883(void)
{
I2C_start();  //2  
I2C_send (0x3C);    //write to HMC
I2C_send (0x03);    //conf mode register 
I2C_stop();
Delay(10);
I2C_start();  //2  
I2C_send (0x3D);    //write to HMC
read_byte();
DATA = SSPBUF;  //.    
I2C_stop();
SSPIF = 0;
DATA_X = (DATA<<8)&0xFF00;
Delay(10);

I2C_start();  //2  
I2C_send (0x3C);    //write to HMC
I2C_send (0x04);    //conf mode register 
I2C_stop();
Delay(10);
I2C_start();  //2  
I2C_send (0x3D);    //write to HMC
read_byte();
DATA = SSPBUF;  //.    
I2C_stop();
SSPIF = 0;
DATA = (DATA&0x00FF);
DATA_X = DATA_X|DATA;
Delay(10);

I2C_start();  //2  
I2C_send (0x3C);    //write to HMC
I2C_send (0x07);    //conf mode register 
I2C_stop();
Delay(10);
I2C_start();  //2  
I2C_send (0x3D);    //write to HMC
read_byte();
DATA = SSPBUF;  //.    Y
I2C_stop();
SSPIF = 0;
DATA_Y = (DATA<<8)&0xFF00;
Delay(10);

I2C_start();  //2  
I2C_send (0x3C);    //write to HMC
I2C_send (0x08);    //conf mode register 
I2C_stop();
Delay(10);
I2C_start();  //2  
I2C_send (0x3D);    //write to HMC
read_byte();
DATA = SSPBUF;  //.    Y
I2C_stop();
SSPIF = 0;
DATA = (DATA&0x00FF);
DATA_Y = DATA_Y|DATA;
Delay(10);

I2C_start();  //2  
I2C_send (0x3C);    //write to HMC
I2C_send (0x05);    //conf mode register 
I2C_stop();
Delay(10);
I2C_start();  //2  
I2C_send (0x3D);    //write to HMC
read_byte();
DATA = SSPBUF;  //.    Z
I2C_stop();
SSPIF = 0;
DATA_Z = (DATA<<8)&0xFF00;
Delay(50);

I2C_start();  //2  
I2C_send (0x3C);    //write to HMC
I2C_send (0x06);    //conf mode register 
I2C_stop();
Delay(10);
I2C_start();  //2  
I2C_send (0x3D);    //write to HMC
read_byte();
DATA = SSPBUF;  //.    Z
I2C_stop();
SSPIF = 0;
DATA = (DATA&0x00FF);
DATA_Z = DATA_Z|DATA;
Delay(10);
}




void READ_QMC5883(void)
{


I2C_start();  //2  
I2C_send (0x1A);    //write to HMC
I2C_send (0x01);    //conf mode register 
I2C_stop();
Delay(10);
I2C_start();  //2  
I2C_send (0x1B);    //write to HMC
read_byte();
DATA = SSPBUF;  //.    
I2C_stop();
SSPIF = 0;
DATA_X = (DATA<<8)&0xFF00;
Delay(50);

I2C_start();  //2  
I2C_send (0x1A);    //write to HMC
I2C_send (0x00);    //conf mode register 
I2C_stop();
Delay(10);
I2C_start();  //2  
I2C_send (0x1B);    //write to HMC
read_byte();
DATA = SSPBUF;  //.    
I2C_stop();
SSPIF = 0;
DATA = (DATA&0x00FF);
DATA_X = DATA_X|DATA;
Delay(50);

I2C_start();  //2  
I2C_send (0x1A);    //write to HMC
I2C_send (0x03);    //conf mode register 
I2C_stop();
Delay(10);
I2C_start();  //2  
I2C_send (0x1B);    //write to HMC
read_byte();
DATA = SSPBUF;  //.    Y
I2C_stop();
SSPIF = 0;
DATA_Y = (DATA<<8)&0xFF00;
Delay(50);

I2C_start();  //2  
I2C_send (0x1A);    //write to HMC
I2C_send (0x02);    //conf mode register 
I2C_stop();
Delay(10);
I2C_start();  //2  
I2C_send (0x1B);    //write to HMC
read_byte();
DATA = SSPBUF;  //.    Y
I2C_stop();
SSPIF = 0;
DATA = (DATA&0x00FF);
DATA_Y = DATA_Y|DATA;
Delay(50);

I2C_start();  //2  
I2C_send (0x1A);    //write to HMC
I2C_send (0x05);    //conf mode register 
I2C_stop();
Delay(10);
I2C_start();  //2  
I2C_send (0x1B);    //write to HMC
read_byte();
DATA = SSPBUF;  //.    Z
I2C_stop();
SSPIF = 0;
DATA_Z = (DATA<<8)&0xFF00;
Delay(50);

I2C_start();  //2  
I2C_send (0x1A);    //write to HMC
I2C_send (0x04);    //conf mode register 
I2C_stop();
Delay(10);
I2C_start();  //2  
I2C_send (0x1B);    //write to HMC
read_byte();
DATA = SSPBUF;  //.    Z
I2C_stop();
SSPIF = 0;
DATA = (DATA&0x00FF);
DATA_Z = DATA_Z|DATA;
Delay(50);

}




void ZAP_DO(void)
{
   while(WR == 1)  //     
		; 
   EEADR = 200;       //  EEPROM
   EEDATA = DO;  //  
   EEPGD = 0;       //   
   WREN = 1;        // 
   GIE = 0;         // 
   EECON2 = 0x55;     // ....
   EECON2 = 0xAA;
   WR = 1;          //
   GIE = 1;         // 
   WREN = 0;        // 
}


void ZAP_MA(void)
{
   while(WR == 1)  //     
		; 
   EEADR = 201;       //  EEPROM
   EEDATA = MA;  //  
   EEPGD = 0;       //   
   WREN = 1;        // 
   GIE = 0;         // 
   EECON2 = 0x55;     // ....
   EECON2 = 0xAA;
   WR = 1;          //
   GIE = 1;         // 
   WREN = 0;        // 
}


void ZAP_GN(void)
{
   while(WR == 1)  //     
		; 
   EEADR = 202;       //  EEPROM
   EEDATA = GN;  //  
   EEPGD = 0;       //   
   WREN = 1;        // 
   GIE = 0;         // 
   EECON2 = 0x55;     // ....
   EECON2 = 0xAA;
   WR = 1;          //
//   GIE = 1;         // 
   WREN = 0;        // 
}


void READ_DO(void)
{
  EEADR = 200;        //  EEPROM
  EEPGD = 0;       //   
  RD = 1;          // 
  DO = EEDATA;  // 
}

void READ_MA(void)
{
  EEADR = 201;        //  EEPROM
  EEPGD = 0;       //   
  RD = 1;          // 
  MA = EEDATA;  // 
}

void READ_GN(void)
{
  EEADR = 202;        //  EEPROM
  EEPGD = 0;       //   
  RD = 1;          // 
  GN = EEDATA;  // 
}



void send_com(void)
{

   WriteCom('D');
   WriteCom('A');
   WriteCom('T');
   WriteCom('A');
   WriteCom(',');

    if(DATA_X>=0x8000)
     {
     WriteCom('-');
     DATA_X=~(DATA_X-1); 
     }

    WriteCom(((DATA_X/10000)%10)|0x30);
    WriteCom(((DATA_X/1000)%10)|0x30);
    WriteCom(((DATA_X/100)%10)|0x30);
    WriteCom(((DATA_X/10)%10)|0x30);
    WriteCom((DATA_X%10)|0x30);
    WriteCom(',');

    if(DATA_Y>=0x8000)
     {
     WriteCom('-');
     DATA_Y=~(DATA_Y-1); 
     }
    
    WriteCom(((DATA_Y/10000)%10)|0x30);
    WriteCom(((DATA_Y/1000)%10)|0x30);
    WriteCom(((DATA_Y/100)%10)|0x30);
    WriteCom(((DATA_Y/10)%10)|0x30);
    WriteCom((DATA_Y%10)|0x30);
    WriteCom(',');
 
    if(DATA_Z>=0x8000)
     {
     WriteCom('-');
     DATA_Z=~(DATA_Z-1); 
     }

    WriteCom(((DATA_Z/10000)%10)|0x30);
    WriteCom(((DATA_Z/1000)%10)|0x30);
    WriteCom(((DATA_Z/100)%10)|0x30);
    WriteCom(((DATA_Z/10)%10)|0x30);
    WriteCom((DATA_Z%10)|0x30);
    WriteCom(',');

    DATA = ((k/10)%10)|0x30;
	WriteCom(DATA);   //  
    DATA = (k%10)|0x30;
	WriteCom(DATA);   //  
    WriteCom(',');
        
    DATA = ((l/10)%10)|0x30;
	WriteCom(DATA);   //  
    DATA = (l%10)|0x30;
	WriteCom(DATA);   //  


    WriteCom(0x0D);   
    WriteCom(0x0A); 

}


void LCD_DATA(unsigned char digit, int count)
{
    //RD3 = 0; (WR = 0  -   )  // LED E RS RW B7 B6 B5 B4  //WH0802
    //RB7 = 0; (RS = 0-,  1-)
    PORTB = (digit>>4)|(0b11100000);  // 
    Delay(count); 
    PORTB = PORTB & 0b10111111;               //
    Delay(count); 
    PORTB = (digit&15)|(0b11100000);  // 
    Delay(count); 
    PORTB = PORTB & 0b10111111;               //
    Delay(count);
}

void LCD_COMM(unsigned char digit, int count)
{
    //RD3 = 0; (WR = 0  -   )  // LED E RS RW B7 B6 B5 B4
    //RB7 = 0; (RS = 0-,  1-)
    PORTB = (digit>>4)|(0b11000000);  // 
    Delay(count);
    PORTB = PORTB & 0b10111111;               //
    Delay(count); 
    PORTB = (digit&15)|(0b11000000);  // 
    Delay(count);
    PORTB = PORTB & 0b10111111;               //
    Delay(count);
}




void Dysplay_init(void)
{


LCD_COMM(0x03,200); //4- 
LCD_COMM(0x02,200); //4- 
LCD_COMM(0x28,200); //4- 
LCD_COMM(0x10,200); //4- 
//LCD_COMM(0x08,200); // 
LCD_COMM(0x01,200); // DDRAM     0x00
Delay(3000);
LCD_COMM(0x06,200); // ,   
LCD_COMM(0x0c,200); // ,   

}



void Convertation(void)
{

if(DATA_H>=0xF000)
{
znak='-';
DATA_H=~(DATA_H-1); 
}
else znak='+';

DATA_H=DATA_H*10;

if(GN==0)
DATA_H=DATA_H/137;
if(GN==1)
DATA_H=DATA_H/109;
if(GN==2)
DATA_H=DATA_H/82;
if(GN==3)
DATA_H=DATA_H/66;
if(GN==4)
DATA_H=DATA_H/44;
if(GN==5)
DATA_H=DATA_H/39;
if(GN==6)
DATA_H=DATA_H/33;
if(GN==7)
DATA_H=DATA_H/23; //   .   (,   )


}








void Dysplay(void)
{
	char i;
    unsigned int V=0;
    unsigned int digit;
    unsigned int code;


//PORTB=0b11000000;  // LED E RS RW B7 B6 B5 B4 //1

LCD_COMM(0x01,200); // DDRAM     0x00

LCD_DATA('X',200); 
DATA_H=DATA_X;
Convertation();
LCD_DATA(znak,200); 
digit=(DATA_H/100)%10;
LCD_DATA(mas8[digit],200); 
LCD_DATA(',',200); 
digit=(DATA_H/10)%10;
LCD_DATA(mas8[digit],200); 
digit=DATA_H%10;
LCD_DATA(mas8[digit],200); 

LCD_COMM(0xC0,2000); //2
LCD_DATA('Y',200); //y
DATA_H=DATA_Y;
Convertation();
LCD_DATA(znak,200); 
digit=(DATA_H/100)%10;
LCD_DATA(mas8[digit],200); 
LCD_DATA(',',200); 
digit=(DATA_H/10)%10;
LCD_DATA(mas8[digit],200); 
digit=DATA_H%10;
LCD_DATA(mas8[digit],200); 

LCD_DATA(' ',200);
LCD_DATA(mas8[GN],200); 


Delay(65000);




}

void Izmerenie (void)
{
    READ_HMC5883();  
     send_com();  
    Delay(2000);  
}

void Izmerenie8 (void)
{
unsigned char w;
 for(w=0; w<8; w++)
    {
    READ_HMC5883();  
    DATA_XM[w]=DATA_X;
    DATA_YM[w]=DATA_Y;
    DATA_ZM[w]=DATA_Z;
    Delay(2000);
    }
    DATA_X=0;
    DATA_Y=0;
    DATA_Z=0;

 for(w=0; w<8; w++)
    {
    DATA_X=DATA_X+DATA_XM[w];
    DATA_Y=DATA_Y+DATA_YM[w];
    DATA_Z=DATA_Z+DATA_ZM[w];
    }

 DATA_X=DATA_X/8;
 DATA_Y=DATA_Y/8;
 DATA_Z=DATA_Z/8;
 send_com();    
}

void Motor1down (unsigned int Steps)
{
    for(i=0; i<Steps; i++)
    {
        RA0=1;//motor X Down (smal)
        RA1=0;
        RA2=0;
        RA3=0;
        Delay(tms);

        RA0=1;
        RA1=0;
        RA2=0;
        RA3=1;
        Delay(tms);       

        RA0=0;
        RA1=0;
        RA2=0;
        RA3=1;
        Delay(tms);
           
        RA0=0;
        RA1=1;
        RA2=0;
        RA3=1;
        Delay(tms);

        
        RA0=0;
        RA1=1;
        RA2=0;
        RA3=0;
        Delay(tms);


        RA0=0;
        RA1=1;
        RA2=1;
        RA3=0;
        Delay(tms);   
 
        RA0=0;
        RA1=0;
        RA2=1;
        RA3=0;
        Delay(tms);

           
        RA0=1;
        RA1=0;
        RA2=1;
        RA3=0;
        Delay(tms);

        
       // if(RD1==1)  // NASTROIT I RASCOMMENTIT
        //   Steps=0; 
    }
    RA0=0;
    RA1=0;
    RA2=0;
    RA3=0;
}


void Motor1up (unsigned int Steps)
{
    for(i=0; i<Steps; i++)
    {      
        RA0=1;//motor X Up (smal)
        RA1=0;
        RA2=0;
        RA3=0;
        Delay(tms);


        RA0=1;
        RA1=0;
        RA2=1;
        RA3=0;
        Delay(tms);   
   
 
        RA0=0;
        RA1=0;
        RA2=1;
        RA3=0;
        Delay(tms);
           
        RA0=0;
        RA1=1;
        RA2=1;
        RA3=0;
        Delay(tms);
        
        RA0=0;
        RA1=1;
        RA2=0;
        RA3=0;
        Delay(tms);

        RA0=0;
        RA1=1;
        RA2=0;
        RA3=1;
        Delay(tms);    
 
        RA0=0;
        RA1=0;
        RA2=0;
        RA3=1;
        Delay(tms);

           
        RA0=1;
        RA1=0;
        RA2=0;
        RA3=1;
        Delay(tms);

    }
    RA0=0;
    RA1=0;
    RA2=0;
    RA3=0;
}


void Motor2down (unsigned int Steps)
{
    for(i=0; i<Steps; i++)
    {
        RA5=1;//motor Y Down (smal)
        RE0=0;
        RE1=0;
        RE2=0;
        Delay(tms);


        RA5=1;
        RE0=0;
        RE1=0;
        RE2=1;
        Delay(tms);  
     
 
        RA5=0;
        RE0=0;
        RE1=0;
        RE2=1;
        Delay(tms);
           
        RA5=0;
        RE0=1;
        RE1=0;
        RE2=1;
        Delay(tms);

        
        RA5=0;
        RE0=1;
        RE1=0;
        RE2=0;
        Delay(tms);


        RA5=0;
        RE0=1;
        RE1=1;
        RE2=0;
        Delay(tms); 
     
 
        RA5=0;
        RE0=0;
        RE1=1;
        RE2=0;
        Delay(tms);

           
        RA5=1;
        RE0=0;
        RE1=1;
        RE2=0;
        Delay(tms);

        
       // if(RD0==1)  // NASTROIT I RASCOMMENTIT
        //   Steps=0; 
    }
    RA5=0;
    RE0=0;
    RE1=0;
    RE2=0;
}


void Motor2up (unsigned int Steps)
{
    for(i=0; i<Steps; i++)
    {      
        RA5=1;//motor Y Up (smal)
        RE0=0;
        RE1=0;
        RE2=0;
        Delay(tms);


        RA5=1;
        RE0=0;
        RE1=1;
        RE2=0;
        Delay(tms);  
     
 
        RA5=0;
        RE0=0;
        RE1=1;
        RE2=0;
        Delay(tms);

           
        RA5=0;
        RE0=1;
        RE1=1;
        RE2=0;
        Delay(tms);

        
        RA5=0;
        RE0=1;
        RE1=0;
        RE2=0;
        Delay(tms);


        RA5=0;
        RE0=1;
        RE1=0;
        RE2=1;
        Delay(tms);  

        RA5=0;
        RE0=0;
        RE1=0;
        RE2=1;
        Delay(tms);

           
        RA5=1;
        RE0=0;
        RE1=0;
        RE2=1;
        Delay(tms);

    }
    RA5=0;
    RE0=0;
    RE1=0;
    RE2=0;
}



void Ciklup2(void)
{
    for(k=1; k<47; k++)
    {   
        if((k&1)==0)
        Motor1up(3); //3
        else  Motor1up(4);  //4
        Delay(10000);  
        Izmerenie();
    }

}

void Cikldown2(void)
{
    for(k=46; k>0; k--)
    {
        Delay(10000); 
        Izmerenie();       
        if((k&1)==0)
        Motor1down(3);  //3
        else  Motor1down(4); //4
    }

}



void Ciklup5(void)
{
    for(k=1; k<18; k++)
    {   
        if((k&1)==0)
        Motor1up(6);
        else  Motor1up(7);
        Delay(10000);  
        Izmerenie();
    }

}

void Cikldown5(void)
{
    for(k=17; k>0; k--)
    {
        Delay(10000); 
        Izmerenie();       
        if((k&1)==0)
        Motor1down(6);
        else  Motor1down(7);
    }

}

void Ciklup10(void)
{
    for(k=1; k<9; k++)
    {      
        Motor1up(12);
        Delay(10000);  
        Izmerenie();
    }

}

void Cikldown10(void)
{
    for(k=8; k>0; k--)
    {  
        Delay(10000);         
        Izmerenie();    
        Motor1down(12);
    }

}








void main(void)
{  

    TMR0=0;
//	OPTION= 0b11010000; // 1:2
	T0IE=1;             //   
	GIE=1;	            //  


    TRISA=0b00000000;          //-0  -1	
    TRISB=0;          //-0	
    TRISC=0b10111111; //uart  
    TRISE=0;
    TRISD=0b11111111;
    
    PORTA=0;  //   
	PORTB=0;  // 
	PORTC=0;  
	PORTD=0;  //   
	PORTE=0;  //   
    
    BRGH=1;                           // BRGH 1-    6 - 57.600             50 -9.600       24 - 19.200
    SPBRG=50; // UART  8MHz   BRGH 0-   (2)-31.250-MIDI        (12)- 9.600     (50)-2.400
    TXEN=1; //  uart              
	CREN=1;  //  uart
	SPEN=1;  // uart 
	SYNC=0;  //  
    RCIF=0;  //,     uart


    
    ADCON0 = 0b01000001; //   |  (F/8) | -   - (AN0) |   | 0 |    
    ADCON1 = 0b10000110; //   0b10000110 -  ,  0b10001110-    AN0
    CCP1CON = 0;
    CCP2CON = 0;

    SSPCON=0b00101000;  //   2  0b00101011
    SSPADD = 19; //   2 Ft=Fosc/(4*(SSPADD+1))  19=100k / 9=200k  Fosc = 8M
    SSPSTAT = 0b10000000;
    SSPCON2 = 0b00000000;
    
   Delay(250);
  // READ_DO();
 //  READ_MA();
 //  READ_GN();
   Delay(10000);
 
  // Dysplay_init();
      Delay(10000);
      Delay(10000);
   Delay(10000);
      Delay(10000);
      Delay(10000);
   Delay(10000);
 /////////////// Motor1up(13);// 5
  /////////////////Motor2up(1400);// 5 1284
   WriteCom('C');
   WriteCom('L');
   WriteCom('E');
   WriteCom('A');
   WriteCom('R');
   WriteCom('D');
   WriteCom('A');
   WriteCom('T');
   WriteCom('A');
   WriteCom(',');
   WriteCom(0x0D);   
   WriteCom(0x0A);  
   
   WriteCom('C');
   WriteCom('L');
   WriteCom('E');
   WriteCom('A');
   WriteCom('R');
   WriteCom('D');
   WriteCom('A');
   WriteCom('T');
   WriteCom('A');
   WriteCom(',');
   WriteCom(0x0D);   
   WriteCom(0x0A);  
   
   WriteCom('L');
   WriteCom('A');
   WriteCom('B');
   WriteCom('E');
   WriteCom('L');
   WriteCom(',');
   WriteCom('X');
   WriteCom(',');
   WriteCom('Y');
   WriteCom(',');
   WriteCom('Z');
   
   WriteCom(',');
   WriteCom('');
   WriteCom('');
   WriteCom('');
   WriteCom(',');
   WriteCom('');
   WriteCom('');
   WriteCom('');
   WriteCom('');
   WriteCom('');
   WriteCom('');
   WriteCom('');
   
   WriteCom(',');
   WriteCom('m');
   WriteCom('a');
   WriteCom('x');
   WriteCom('H');
   WriteCom(',');
  WriteCom(0x37); // 8Gauss  HMC5883
  //WriteCom(0x39); // 8Gauss  QMC5883
   WriteCom(',');
   WriteCom(0x0D);   
   WriteCom(0x0A); 

  
     LOAD_HMC5883();
 //  LOAD_QMC5883();     
    

   
    while(RD0==0)
    Motor2down(10);//    Y
   
    while(RD1==0)
    Motor1down(10); //    X
  
    START=1;
	while(1==1)     ////////////  ///////////////////////////////////////////////////////////////////////////
	{   
               if(START==1)
               Izmerenie(); 
 
         if(START==2)
      { 
        for(l=0; l<50; l++)
        {
           if((l&1)==0)
           {
             Delay(9000);
             k=0;
             Izmerenie();
            Delay(1000);
             Ciklup2(); 
             Motor2up(3);	//3
           }
           else {
                 Cikldown2(); 
                 Delay(9000);  
                 Izmerenie(); 
                Delay(1000);
                 if(l<49)
                 Motor2up(4);  //4 
                } 
        }
         START=0;
      }  
      


     
      if(START==5)
      { 
        for(l=0; l<18; l++)
        {
           if((l&1)==0)
           {
             Delay(12000);
             k=0;
             Izmerenie();
             Ciklup5(); 
             Motor2up(12);
           }
           else {
                 Cikldown5(); 
                 Delay(12000);  
                 Izmerenie(); 
                 if(l<17)
                 Motor2up(13);   
                } 
        }
         START=56;
      }  
      
      
      if(START==10)
      { 
           for(l=0; l<9; l++)
        {
           if((l&1)==0)
           {
             Delay(12000);
             k=0;
             Izmerenie();
             Ciklup5(); 
             if(l<8)
             Motor2up(2800);
           }
           else {
                 Cikldown5(); 
                 Delay(12000);  
                 Izmerenie(); 
                 Motor2up(2800);   
                } 
        }
         START=0;
      } 
      
            if(START==55)  //    
            {
                 for(k=1; k<9; k++)
                 {      
                    if((k&1)==0)
                    Motor1up(12);
                    else  Motor1up(13);  
                 }   
                 Motor1up(6);
                  
                 for(k=0; k<8; k++)
                 {      
                    Motor2up(1300);
                 }                
                 Motor2up(895);
            START=0;        
            }
      
                if(START==56)  //   
            {
                 for(k=1; k<9; k++)
                 {      
                    if((k&1)==0)
                    Motor1up(12);
                    else  Motor1up(13);  
                 }   
                 Motor1up(6);
                  
                 for(k=0; k<8; k++)
                 {      
                    Motor2down(13);
                 }                
            START=0;        
            }


   // READ_HMC5883();

 //   send_com();

    //Delay2(((~DO&0x07)*4)+1);

   // Dysplay();


/*
if(RCIF)
	    {	
		    if(RCREG == 0xFF)
		    RXDAT = 0;
			
            RXDAT = (RXDAT + 1);

	       if(RXDAT == 0x04)  //  
            {
			 GN = (RCREG&0x07);  //
			 DO = ((RCREG>>3)&0x07); //
			 MA = ((RCREG>>6)&0x03);  //
             LOAD_HMC5883();   //
             Delay2(10);
             ZAP_DO();
             ZAP_MA();
             ZAP_GN();
            }
		
        }    
*/

	}	
}






